on startMovie
  global gCursor, gLstMainMap, gLstMainHouse, gLstFloorPlan, gLstField, gBoolSummary, gChapter, gBookMark, gBookList, gMainPath
  set gMainPath to checkMainPath()
  set the textSize of member "ccTextBox" to 12
  set gLstMainMap to [13: 0, 14: 0, 15: 0, 16: 0, 17: 0, 18: 0, 19: 0, 20: 0, 21: 0]
  set gLstMainHouse to [8: 0]
  set gLstFloorPlan to [11: 0, 12: 0, 13: 0, 14: 0, 15: 0]
  set gLstField to [10: 0, 11: 0, 12: 0]
  set gBoolSummary to 0
  set the text of member "notebook text field" to " "
  hIcons(0, 0, 0, 1)
  hFYI(0)
  hFlashlight(0)
  hVisibleSprite(0, 29, 34)
  set the cursor of sprite 42 to [member "finger", member "finger mask"]
  set the cursor of sprite 45 to [member "finger", member "finger mask"]
  set the visible of sprite 46 to 0
  set the visible of sprite 47 to 0
  set notetext to the number of member "notebook text field"
  set the text of member notetext to " "
  set the textFont of member notetext to "helvetica"
  set the textSize of member notetext to 14
  set the margin of member notetext to 3
  set the textStyle of member notetext to "plain"
  set the editableText of sprite 42 to 1
  if not voidp(gBookList) then
    set mybookmark to getAt(gBookList, 2)
  end if
  if mybookmark <> 0 then
    LoadBookMark()
  end if
  hCCInitialSetup(25)
end

on SAveBookmark
  global gBookMark, gBookList, gLstMainMap
  set gBookMark to string(gLstMainMap)
end

on LoadBookMark
  global gBookList, gLstMainMap
  set myList to []
  do("set mylist =  " & getAt(gBookList, 2))
  if not voidp(myList) and listp(myList) then
    set gLstMainMap to duplicate(myList)
  end if
end

on hpuppet vTRUEorFALSE, vFirstSprite, vLastSprite
  if vFirstSprite = vLastSprite then
    puppetSprite(vFirstSprite, vTRUEorFALSE)
  else
    repeat with n = vFirstSprite to vLastSprite
      puppetSprite(n, vTRUEorFALSE)
      set the stretch of sprite n to 0
    end repeat
  end if
end

on hVisibleSprite vTRUEorFALSE, vFirstSprite, vLastSprite
  if vFirstSprite = vLastSprite then
    set the visible of sprite vFirstSprite to vTRUEorFALSE
  else
    repeat with n = vFirstSprite to vLastSprite
      set the visible of sprite n to vTRUEorFALSE
    end repeat
  end if
end

on hDisplay lIntTransition, lInttransTime, lIntWhichSprite, lIntwhichMember, lIntLocA, lIntLocB
  puppetTransition(lIntTransition, lInttransTime)
  set the castNum of sprite lIntWhichSprite to the number of member lIntwhichMember
  set the stretch of sprite lIntWhichSprite to 0
  set the loc of sprite lIntWhichSprite to point(lIntLocA, lIntLocB)
end

on hCursor vTRUEorFALSE, vWhichCursor, vFirstSprite, vLastSprite
  global gCursor
  set lStrCursorMask to vWhichCursor && "mask"
  set gCursor to [the number of member vWhichCursor, the number of member lStrCursorMask]
  if vTRUEorFALSE = 1 then
    if vFirstSprite = vLastSprite then
      set the cursor of sprite vFirstSprite to gCursor
    else
      repeat with n = vFirstSprite to vLastSprite
        set the cursor of sprite n to gCursor
      end repeat
    end if
  else
    if vFirstSprite = vLastSprite then
      set the cursor of sprite vFirstSprite to 0
    else
      repeat with n = vFirstSprite to vLastSprite
        set the cursor of sprite n to 0
      end repeat
    end if
  end if
end

on hNoteBook
  global gLstNoteBook
  put the text of member "notebook text field" && RETURN & RETURN into field "notebook text field"
  set NotebookLines to the lineCount of member "notebook text field"
  set the scrollTop of member "notebook text field" to (NotebookLines * 16) + 1
  set the visible of sprite 33 to 1
  set the loc of sprite 33 to point(320, 240)
  set the visible of sprite 32 to 1
  hCursor(1, "finger", 32, 32)
  set the visible of sprite 34 to 1
  set the editableText of sprite 34 to 1
  updateStage()
  set the selEnd to length(field "notebook text field")
  set the selStart to length(field "notebook text field") + 1
  updateStage()
end

on hHighLight vWhichSprite, vHighLightChannel
  if rollOver(vWhichSprite) then
    hVisibleSprite(1, vHighLightChannel, vHighLightChannel)
  else
    hVisibleSprite(0, vHighLightChannel, vHighLightChannel)
  end if
end

on hChickletState vwhichMember, vWhichSound
  set clickSprite to the clickOn
  set h to the locH of sprite clickSprite
  set v to the locV of sprite clickSprite
  if vWhichSound = 0 then
    nothing()
  else
    hSound(vWhichSound)
  end if
  hDisplay(0, 0, clickSprite, vwhichMember, h, v)
end

on hSound lStrWhichSound
  if the machineType = 256 then
    sound playFile 1, the pathName & "audio\" & lStrWhichSound
  else
    sound playFile 1, the pathName & "audio:" & lStrWhichSound
  end if
end

on hSetProp lStrWhichList, lBoolTRUEorFALSE
  set lIntthisSprite to the clickOn
  setProp(lStrWhichList, lIntthisSprite, lBoolTRUEorFALSE)
end

on hIcons lBoolMainMap, lBoolNoteBook, lBoolCheckPlus, lBoolBackPack
  if lBoolMainMap then
    hVisibleSprite(1, 35, 35)
    hCursor(1, "finger", 35, 35)
  else
    hVisibleSprite(0, 35, 35)
    hCursor(0, "finger", 35, 35)
  end if
  if lBoolNoteBook then
    hVisibleSprite(1, 36, 36)
    hCursor(1, "finger", 36, 36)
  else
    hVisibleSprite(0, 36, 36)
    hCursor(0, "finger", 36, 36)
  end if
  if lBoolCheckPlus then
    hVisibleSprite(1, 38, 38)
    hCursor(1, "finger", 38, 38)
  else
    hVisibleSprite(0, 38, 38)
    hCursor(0, "finger", 38, 38)
  end if
  if lBoolBackPack then
    hVisibleSprite(1, 40, 40)
    hCursor(0, "finger", 40, 40)
  end if
end

on hFYI lBoolFYI
  if lBoolFYI then
    hSound("FYI")
    hVisibleSprite(1, 37, 37)
    hCursor(1, "finger", 37, 37)
    fyiflash()
  else
    hVisibleSprite(0, 37, 37)
    hCursor(0, "finger", 37, 37)
  end if
end

on fyiflash
  cursor(200)
  set fyisprite to 37
  set the visible of sprite fyisprite to 1
  updateStage()
  puppetSprite(fyisprite, 1)
  repeat with y = 1 to 5
    set the visible of sprite fyisprite to 0
    updateStage()
    hWaitaSec(0.30000000000000004)
    set the visible of sprite fyisprite to 1
    updateStage()
    hWaitaSec(0.30000000000000004)
  end repeat
  puppetSprite(fyisprite, 0)
  cursor(0)
end

on hWaitaSec howmany
  if voidp(howmany) then
    set howmany to 1
  end if
  set thistick to the ticks
  repeat while (thistick + (howmany * 60)) > the ticks
  end repeat
end

on hFlashlight lBoolFlashLight
  if lBoolFlashLight then
    hVisibleSprite(1, 39, 39)
    hCursor(1, "finger", 39, 39)
    hpuppet(1, 39, 39)
  else
    hVisibleSprite(0, 39, 39)
    hCursor(0, "finger", 39, 39)
    hpuppet(0, 39, 39)
  end if
end

on hmouseCast vWhichSpriteRoll, vWhichUnHide
  set lIntCastNum to the memberNum of sprite vWhichSpriteRoll
  if rollOver(vWhichSpriteRoll) and (the mouseCast = lIntCastNum) then
    hVisibleSprite(1, vWhichUnHide, vWhichUnHide)
  end if
end

on hAllItemsdonep
  global gLstMainMap, gBoolSummary
  if gBoolSummary = 0 then
    set lBoolMapItemDone13p to getProp(gLstMainMap, 13)
    set lBoolMapItemDone14p to getProp(gLstMainMap, 14)
    set lBoolMapItemDone15p to getProp(gLstMainMap, 15)
    set lBoolMapItemDone16p to getProp(gLstMainMap, 16)
    set lBoolMapItemDone17p to getProp(gLstMainMap, 17)
    set lBoolMapItemDone18p to getProp(gLstMainMap, 18)
    set lBoolMapItemDone19p to getProp(gLstMainMap, 19)
    set lBoolMapItemDone20p to getProp(gLstMainMap, 20)
    set lBoolMapItemDone21p to getProp(gLstMainMap, 21)
    if lBoolMapItemDone13p and lBoolMapItemDone14p and lBoolMapItemDone15p and lBoolMapItemDone16p and lBoolMapItemDone17p and lBoolMapItemDone18p and lBoolMapItemDone19p and lBoolMapItemDone20p and lBoolMapItemDone21p then
      hCursor(0, "finger", 1, 7)
      hIcons(1, 1, 1, 1)
      hFlashlight(0)
      hFYI(0)
      go("summary")
    end if
  end if
end

on takeFive startBreak, delayInterval
  repeat while the ticks < (startBreak + delayInterval)
    nothing()
  end repeat
end

on stopMovie
  global gCursor, gLstMainMap, gLstMainHouse, gLstFloorPlan, gLstField, gBoolSummary, gChapter
  set gCursor to EMPTY
  set gLstMainMap to EMPTY
  set gLstMainHouse to EMPTY
  set gLstFloorPlan to EMPTY
  set gLstField to EMPTY
  set gBoolSummary to EMPTY
end
